from IntCode import *
import sys

def resposta(letra):
    d = {"a":10987514, "b":13547311, "c":16489636, 
         "d":7259358, "e":13294380, "f":16489636}
    return d[letra]
    
def main():

    if len(sys.argv) < 2:
        print("Uso: python ex02.py letra")
        return

    letra = sys.argv[1]
    if letra not in ["a","b","c","d","e","f"]:
        print("A letra deve ser entre a e f")
        return


    entrada = leiaArquivo(f"entradas/day05{letra}.txt")
    m = criaMaquina(entrada)
    
    ''' Verificações de corretude '''
    print("Testes iniciais:\n")
    print(f"opcode(1234) = {opcode(1234)}")
    print(f"pegaModoN(123, 1) = {pegaModoN(123,1)}")
    print(f"pegaModoN(123, 2) = {pegaModoN(123,2)}")
    print(f"pegaModoN(123, 3) = {pegaModoN(123,3)}\n")
    print(f"Com o valor de entrada=1 a saída deve ser {resposta(letra)}")
    (_, saidas) = executa(m, 1)
    t = saidas[-1]==resposta(letra)
    print(f"A saída foi {saidas[-1]}! Passou? {t}\n")
    
    ''' Resposta ''' 
    m = criaMaquina(entrada)
    (_, saidas) = executa(m, 5)
    print(f"A resposta para a letra {letra} é {saidas[-1]}!\n")

if __name__ == "__main__":
    main()
